// src/index.ts
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
var slicing = function(text, searchWords) {
    var match = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : function(word) {
        return new RegExp("\\b".concat(word, "\\b"), "gi");
    };
    return Array.from(new Set(searchWords)).filter(function(word) {
        return !!word;
    }).map(function(word) {
        return word;
    }).reduce(function(slices, word) {
        var matched;
        var regex = match(word);
        while(matched = regex.exec(text)){
            var start = matched.index;
            var end = regex.lastIndex;
            if (end > start) {
                slices.push({
                    start: start,
                    end: end
                });
            }
        }
        return slices;
    }, []);
};
var mergeOverlap = function(slices) {
    if (slices.length === 0) return slices;
    var sortedSlices = slices.toSorted(function(a, b) {
        return a.start - b.start;
    });
    var merged = [];
    var _sortedSlices = _sliced_to_array(sortedSlices, 1), current = _sortedSlices[0];
    for(var i = 1; i < sortedSlices.length; i++){
        var next = sortedSlices[i];
        if (current && next) {
            if (next.start <= current.end) {
                current = {
                    start: current.start,
                    end: Math.max(current.end, next.end)
                };
            } else {
                merged.push(current);
                current = _object_spread({}, next);
            }
        }
    }
    if (current) merged.push(current);
    return merged;
};
var fillSliceGaps = function(slices) {
    var textLength = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    if (textLength === 0) return [];
    var matchedSlices = [];
    var push = function(start, end, matched) {
        if (end - start > 0) {
            matchedSlices.push({
                start: start,
                end: end,
                matched: matched
            });
        }
    };
    if (slices.length === 0) {
        push(0, textLength, false);
    } else {
        var startIndex = 0;
        slices.forEach(function(slice) {
            push(startIndex, slice.start, false);
            push(slice.start, slice.end, true);
            startIndex = slice.end;
        });
        push(startIndex, textLength, false);
    }
    return matchedSlices;
};
var sliceText = function(text, searchWords, match) {
    return fillSliceGaps(mergeOverlap(slicing(text, searchWords, match)), text.length);
};
export { fillSliceGaps, mergeOverlap, sliceText, slicing };
//# sourceMappingURL=index.js.map